import numpy as np
import json

import os, sys
if 'SUMO_HOME' in os.environ:
    tools = os.path.join(os.environ['SUMO_HOME'], 'tools')
    sys.path.append(tools)
else:
    sys.exit("please declare environment variable 'SUMO_HOME'")

import traci

def make_move(min_simulation_time, additional_veh_ID):
    for _ in range(min_simulation_time):
        if traci.simulation.getMinExpectedNumber() <= 10:
            additional_veh_ID = add_cars(additional_veh_ID)
        traci.simulationStep()
    return additional_veh_ID

def generate_moves(phase):
    if 'y' in phase:
        return [5]
    else:
        return [10,15,20,25,30]

def save_data(filename, data):
    with open(filename, 'w') as outfile:
        json.dump(data, outfile)
        # print(data)
        outfile.close()

def load_data(filename):
    with open(filename) as outfile:
        data = json.load(outfile)
        outfile.close()
        return data

def add_cars(additional_veh_ID):
    probability = np.random.uniform(0,1)
    if probability > 0.8:
        no_cars = np.random.randint(1,2)
        additional_route_ID = traci.route.getIDList()
        #additional_route_ID = ["route_1","route_4"]
        for i in range(no_cars):
            vehID = "addtionVehical."+str(additional_veh_ID)
            additional_veh_ID += 1
            routeID = np.random.choice(additional_route_ID)
            traci.vehicle.add(vehID, routeID, "car")
    return additional_veh_ID
